diff --git a/src/main/java/net/minecraft/client/render/texture/stitcher/IconCoordinate.java b/src/main/java/net/minecraft/client/render/texture/stitcher/IconCoordinate.java
index f8029c1ca..d135a867f 100644
--- a/src/main/java/net/minecraft/client/render/texture/stitcher/IconCoordinate.java
+++ b/src/main/java/net/minecraft/client/render/texture/stitcher/IconCoordinate.java
@@ -56,6 +56,13 @@ public class IconCoordinate implements Comparable<IconCoordinate> {
         return width * height;
     }
     protected void drawToAtlas(Graphics2D atlas){
+        if (width != _imageStorage.getWidth() || height != _imageStorage.getHeight()) {
+            int[] subImage = _imageStorage.getRGB(0, 0, width, height, null, 0, width);
+            BufferedImage _img = new BufferedImage(width, height, BufferedImage.TYPE_INT_ARGB);
+            _img.setRGB(0, 0, width, height, subImage, 0, width);
+            atlas.drawImage(_img, iconX, iconY, null);
+            return;
+        }
         atlas.drawImage(_imageStorage, iconX, iconY, null);
     }
     public double getIconUMin(){
